// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rc_common_msgs:srv/Trigger.idl
// generated code does not contain a copyright notice

#ifndef RC_COMMON_MSGS__SRV__DETAIL__TRIGGER__TRAITS_HPP_
#define RC_COMMON_MSGS__SRV__DETAIL__TRIGGER__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "rc_common_msgs/srv/detail/trigger__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace rc_common_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const Trigger_Request & msg,
  std::ostream & out)
{
  (void)msg;
  out << "null";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Trigger_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  (void)msg;
  (void)indentation;
  out << "null\n";
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Trigger_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace rc_common_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rc_common_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rc_common_msgs::srv::Trigger_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  rc_common_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rc_common_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const rc_common_msgs::srv::Trigger_Request & msg)
{
  return rc_common_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<rc_common_msgs::srv::Trigger_Request>()
{
  return "rc_common_msgs::srv::Trigger_Request";
}

template<>
inline const char * name<rc_common_msgs::srv::Trigger_Request>()
{
  return "rc_common_msgs/srv/Trigger_Request";
}

template<>
struct has_fixed_size<rc_common_msgs::srv::Trigger_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<rc_common_msgs::srv::Trigger_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<rc_common_msgs::srv::Trigger_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'return_code'
#include "rc_common_msgs/msg/detail/return_code__traits.hpp"

namespace rc_common_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const Trigger_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: return_code
  {
    out << "return_code: ";
    to_flow_style_yaml(msg.return_code, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Trigger_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: return_code
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "return_code:\n";
    to_block_style_yaml(msg.return_code, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Trigger_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace rc_common_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rc_common_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rc_common_msgs::srv::Trigger_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  rc_common_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rc_common_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const rc_common_msgs::srv::Trigger_Response & msg)
{
  return rc_common_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<rc_common_msgs::srv::Trigger_Response>()
{
  return "rc_common_msgs::srv::Trigger_Response";
}

template<>
inline const char * name<rc_common_msgs::srv::Trigger_Response>()
{
  return "rc_common_msgs/srv/Trigger_Response";
}

template<>
struct has_fixed_size<rc_common_msgs::srv::Trigger_Response>
  : std::integral_constant<bool, has_fixed_size<rc_common_msgs::msg::ReturnCode>::value> {};

template<>
struct has_bounded_size<rc_common_msgs::srv::Trigger_Response>
  : std::integral_constant<bool, has_bounded_size<rc_common_msgs::msg::ReturnCode>::value> {};

template<>
struct is_message<rc_common_msgs::srv::Trigger_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<rc_common_msgs::srv::Trigger>()
{
  return "rc_common_msgs::srv::Trigger";
}

template<>
inline const char * name<rc_common_msgs::srv::Trigger>()
{
  return "rc_common_msgs/srv/Trigger";
}

template<>
struct has_fixed_size<rc_common_msgs::srv::Trigger>
  : std::integral_constant<
    bool,
    has_fixed_size<rc_common_msgs::srv::Trigger_Request>::value &&
    has_fixed_size<rc_common_msgs::srv::Trigger_Response>::value
  >
{
};

template<>
struct has_bounded_size<rc_common_msgs::srv::Trigger>
  : std::integral_constant<
    bool,
    has_bounded_size<rc_common_msgs::srv::Trigger_Request>::value &&
    has_bounded_size<rc_common_msgs::srv::Trigger_Response>::value
  >
{
};

template<>
struct is_service<rc_common_msgs::srv::Trigger>
  : std::true_type
{
};

template<>
struct is_service_request<rc_common_msgs::srv::Trigger_Request>
  : std::true_type
{
};

template<>
struct is_service_response<rc_common_msgs::srv::Trigger_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // RC_COMMON_MSGS__SRV__DETAIL__TRIGGER__TRAITS_HPP_
